# Class ThreadSafeDatabase

java.lang.Object
com.codename1.db.Database
com.codename1.db.ThreadSafeDatabase

public class ThreadSafeDatabase extends Database
Wraps all database calls in a single thread so they are all proxied thru that thread

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ThreadSafeDatabase(Database db)`
  Wraps the given database with a threadsafe version

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `beginTransaction()`
  Starts a transaction
  `void`
  `close()`
  Closes the database
  `void`
  `commitTransaction()`
  Commits current transaction
  `void`
  `execute(String sql)`
  Execute an update query.
  `void`
  `execute(String sql, Object... params)`
  Execute an update query with params.
  `void`
  `execute(String sql, String[] params)`
  Execute an update query with params.
  `Cursor`
  `executeQuery(String sql)`
  This method should be called with SELECT type statements that return row set.
  `Cursor`
  `executeQuery(String sql, Object... params)`
  This method should be called with SELECT type statements that return row set it accepts object with params.
  `Cursor`
  `executeQuery(String sql, String[] params)`
  This method should be called with SELECT type statements that return row set.
  `EasyThread`
  `getThread()`
  Returns the underlying easy thread we can use to pipe tasks to the db thread
  `void`
  `rollbackTransaction()`
  Rolls back current transaction

  ### Methods inherited from class Database

  `delete, exists, getDatabasePath, isCustomPathSupported, openOrCreate, supportsWasNull, wasNull`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ThreadSafeDatabase

    public ThreadSafeDatabase(Database db)

    Wraps the given database with a threadsafe version

    ###### Parameters

    - `db`: the database

- ## Method Details

  - ### getThread

    public EasyThread getThread()

    Returns the underlying easy thread we can use to pipe tasks to the db thread

    ###### Returns

    the easy thread object

  - ### beginTransaction

    public void beginTransaction() throws IOException
    Description copied from class: `Database`

    Starts a transaction

    NOTE: Not supported in Javascript port. This method will do nothing when running in Javascript.

    ###### Throws

    - `IOException`: if database is not opened
    Specified by:
      `beginTransaction` in class `Database`
    Throws:
      `IOException`

  - ### commitTransaction

    public void commitTransaction() throws IOException
    Description copied from class: `Database`

    Commits current transaction

    NOTE: Not supported in Javascript port. This method will do nothing when running in Javascript.

    ###### Throws

    - `IOException`: if database is not opened or transaction was not started
    Specified by:
      `commitTransaction` in class `Database`
    Throws:
      `IOException`

  - ### rollbackTransaction

    public void rollbackTransaction() throws IOException
    Description copied from class: `Database`

    Rolls back current transaction

    NOTE: Not supported in Javascript port. This method will do nothing when running in Javascript.

    ###### Throws

    - `IOException`: if database is not opened or transaction was not started
    Specified by:
      `rollbackTransaction` in class `Database`
    Throws:
      `IOException`

  - ### close

    public void close()
    Description copied from class: `Database`

    Closes the database

    ###### Throws

    - `IOException`
    Specified by:
      `close` in class `Database`

  - ### execute

    public void execute(String sql) throws IOException
    Description copied from class: `Database`

    Execute an update query. Used for INSERT, UPDATE, DELETE and similar sql statements.

    ###### Parameters

    - `sql`: the sql to execute

    ###### Throws

    - `IOException`
    Specified by:
      `execute` in class `Database`
    Throws:
      `IOException`

  - ### execute

    public void execute(String sql, String[] params) throws IOException
    Description copied from class: `Database`

    Execute an update query with params. Used for INSERT, UPDATE, DELETE and similar sql statements. The sql can be constructed with '?' and the params will be binded to the query

    ###### Parameters

    - `sql`: the sql to execute

    - `params`: to bind to the query where the '?' exists

    ###### Throws

    - `IOException`
    Specified by:
      `execute` in class `Database`
    Throws:
      `IOException`

  - ### executeQuery

    public Cursor executeQuery(String sql, String[] params) throws IOException
    Description copied from class: `Database`

    This method should be called with SELECT type statements that return row set.

    ###### Parameters

    - `sql`: the sql to execute

    - `params`: to bind to the query where the '?' exists

    ###### Returns

    a cursor to iterate over the results

    ###### Throws

    - `IOException`
    Specified by:
      `executeQuery` in class `Database`
    Throws:
      `IOException`

  - ### executeQuery

    public Cursor executeQuery(String sql) throws IOException
    Description copied from class: `Database`

    This method should be called with SELECT type statements that return row set.

    ###### Parameters

    - `sql`: the sql to execute

    ###### Returns

    a cursor to iterate over the results

    ###### Throws

    - `IOException`
    Specified by:
      `executeQuery` in class `Database`
    Throws:
      `IOException`

  - ### executeQuery

    public Cursor executeQuery(String sql, Object... params) throws IOException
    Description copied from class: `Database`

    This method should be called with SELECT type statements that return row set it accepts object with params.

    ###### Parameters

    - `sql`: the sql to execute

    - `params`: @param params to bind to the query where the '?' exists, supported object types are String, byte[], Double, Long and null

    ###### Returns

    a cursor to iterate over the results

    ###### Throws

    - `IOException`
    Overrides:
      `executeQuery` in class `Database`
    Throws:
      `IOException`

  - ### execute

    public void execute(String sql, Object... params) throws IOException
    Description copied from class: `Database`

    Execute an update query with params. Used for INSERT, UPDATE, DELETE and similar sql statements. The sql can be constructed with '?' and the params will be binded to the query

    ###### Parameters

    - `sql`: the sql to execute

    - `params`: @param params to bind to the query where the '?' exists, supported object types are String, byte[], Double, Long and null

    ###### Throws

    - `IOException`
    Overrides:
      `execute` in class `Database`
    Throws:
      `IOException`